Index: main/cdr.c
===================================================================
--- main/cdr.c	(revision 197692)
+++ main/cdr.c	(working copy)
@@ -102,7 +102,19 @@
 AST_MUTEX_DEFINE_STATIC(cdr_pending_lock);
 static ast_cond_t cdr_pending_cond;
 
+static void ast_cdr_debug_print(struct ast_cdr *cdr)
+{
+	if (!cdr)
+		return;
 
+	if (cdr->next) {
+		ast_log(LOG_DEBUG, "*** SOMETHING IS NOT RIGHT ***\ncdr: %p\ncdr->next: %p\n", cdr, cdr->next);
+	} else {
+		ast_log(LOG_DEBUG, "everything seems normal\ncdr: %p\ncdr->next: %p\n", cdr, cdr->next);
+	}
+}
+
+
 /*! Register a CDR driver. Each registered CDR driver generates a CDR 
 	\return 0 on success, -1 on failure 
 */
@@ -467,6 +479,7 @@
 	struct ast_cdr *x = ast_calloc(1, sizeof(struct ast_cdr));
 	if (!x)
 		ast_log(LOG_ERROR,"Allocation Failure for a CDR!\n");
+	ast_cdr_debug_print(x);
 	return x;
 }
 
@@ -1062,6 +1075,8 @@
 	struct ast_cdr *dup;
 	struct ast_flags flags = { 0 };
 
+	ast_cdr_debug_print(cdr);
+
 	if (_flags)
 		ast_copy_flags(&flags, _flags, AST_FLAGS_ALL);
 
@@ -1098,6 +1113,8 @@
 {
 	struct ast_flags flags = { 0 };
 
+	ast_cdr_debug_print(cdr);
+
 	if (_flags)
 		ast_copy_flags(&flags, _flags, AST_FLAGS_ALL);
 	
